<!DOCTYPE html>
<html lang="en">
    <meta charset="utf-8" />
    <title>Movie Reviews</title>
    <head>
        <link rel="stylesheet" href="https://code.getmdl.io/1.3.0/material.blue_grey-blue.min.css"/> 
        <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">
        <link rel="stylesheet" href="style.css">
        <script src="https://code.getmdl.io/1.3.0/material.min.js"></script>
        <link rel="shortcut icon" type="image/png" href="/favicon.png"/>
        <link rel="stylesheet"
        href="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.18.1/styles/atom-one-dark-reasonable.min.css">
        <script src="//cdnjs.cloudflare.com/ajax/libs/highlight.js/9.18.1/highlight.min.js"></script>
        <script>hljs.initHighlightingOnLoad();</script>
    </head>
    <body>
        <div class="mdl-layout mdl-js-layout mdl-layout--fixed-header">
            <header class="mdl-layout__header">
              <div class="mdl-layout__header-row">
                <span class="mdl-layout-title">IB Personal Project</span>
              </div>
              <div class="mdl-layout__tab-bar mdl-js-ripple-effect mdl-layout--large-screen-only">
                <a href="index.html" class="mdl-layout__tab">Home</a>
                <a href="prices.html" class="mdl-layout__tab">Housing Prices</a>
                <a href="digits.html" class="mdl-layout__tab">Handwritten Digits</a>
                <a href="reviews.html" class="mdl-layout__tab is-active">Movie Reviews</a>
                <a href="entries.html" class="mdl-layout__tab">Journal Entries</a>
              </div>
            </header>
            <div class="mdl-layout__drawer mdl-layout--small-screen-only">
              <span class="mdl-layout__title">IB Personal Project</span>
              <nav class="mdl-navigation">
                <a class="mdl-navigation__link" href="index.html">Home</a>
                <a class="mdl-navigation__link" href="prices.html">Housing Prices</a>
                <a class="mdl-navigation__link" href="digits.html">Handwritten Digits</a>
                <a class="mdl-navigation__link" href="reviews.html">Movie Reviews</a>
                <a class="mdl-navigation__link" href="entries.html">Journal Entries</a>
              </nav>
            </div>
            <main class="mdl-layout__content">
                <div class="mdl-grid">
                    <div class="mdl-cell mdl-cell--4-col"></div>
                    <div class="mdl-cell mdl-cell--4-col centre">
                      <h1>What is this?</h1><br>
                      <p>This is one of the two more polished applications I did. This model uses one of the last concepts that I learned - embeddings, so it performs sentiment analysis on movie review data based on the words in the review.</p>
                    </div>
                    <div class="mdl-cell mdl-cell--4-col"></div>
                </div>
                <div class="page-content">
                  <pre><code class="python">
                    """
                    Convert movie-review data in a sparse feature fector
                    Use a sentiment analysis embedding in two demonsion
                    Display the embedding
                    """
                    from __future__ import print_function

                    import collections
                    import io
                    import math

                    import matplotlib.pyplot as plt
                    import numpy as np
                    import pandas as pd
                    import tensorflow as tf
                    from IPython import display
                    from sklearn import metrics

                    tf.compat.v1.logging.set_verbosity(tf.compat.v1.logging.ERROR)
                    train_url = 'https://download.mlcc.google.com/mledu-datasets/sparse-data-embedding/train.tfrecord'
                    train_path = tf.keras.utils.get_file(train_url.split('/')[-1], train_url)
                    test_url = 'https://download.mlcc.google.com/mledu-datasets/sparse-data-embedding/test.tfrecord'
                    test_path = tf.keras.utils.get_file(test_url.split('/')[-1], test_url)

                    def _parse_function(record):
                      """Extracts features and labels.
  
                      Args:
                        record: File path to a TFRecord file    
                      Returns:
                        A `tuple` `(labels, features)`:
                          features: A dict of tensors representing the features
                          labels: A tensor with the corresponding labels.
                      """
                      features = {
                        "terms": tf.VarLenFeature(dtype=tf.string), # terms are strings of varying lengths
                        "labels": tf.FixedLenFeature(shape=[1], dtype=tf.float32) # labels are 0 or 1
                      }
  
                      parsed_features = tf.parse_single_example(record, features)
  
                      terms = parsed_features['terms'].values
                      labels = parsed_features['labels']

                      return  {'terms':terms}, labels

                    # Create the Dataset object.
                    ds = tf.data.TFRecordDataset(train_path)
                    # Map features and labels with the parse function.
                    ds = ds.map(_parse_function)

                    ds

                    n = ds.make_one_shot_iterator().get_next()
                    sess = tf.Session()
                    sess.run(n)

                    # Create an input_fn that parses the tf.Examples from the given files,
                    # and split them into features and targets.
                    def _input_fn(input_filenames, num_epochs=None, shuffle=True):
  
                      # Same code as above; create a dataset and map features and labels.
                      ds = tf.data.TFRecordDataset(input_filenames)
                      ds = ds.map(_parse_function)

                      if shuffle:
                        ds = ds.shuffle(10000)

                      # The feature data is variable-length, so I pad and batch
                      # each field of the dataset structure to whatever size is necessary.
                      ds = ds.padded_batch(25, ds.output_shapes)
  
                      ds = ds.repeat(num_epochs)

  
                      # Return the next batch of data.
                      features, labels = ds.make_one_shot_iterator().get_next()
                      return features, labels
                    # Download the vocabulary file.
                    terms_url = 'https://download.mlcc.google.com/mledu-datasets/sparse-data-embedding/terms.txt'
                    terms_path = tf.keras.utils.get_file(terms_url.split('/')[-1], terms_url)

                    # Create a feature column from "terms", using a full vocabulary file.
                    informative_terms = None
                    with io.open(terms_path, 'r', encoding='utf8') as f:
                      # Convert it to a set first to remove duplicates.
                      informative_terms = list(set(f.read().split()))
  
                    terms_feature_column = tf.feature_column.categorical_column_with_vocabulary_list(key="terms", 
                                                                                                    vocabulary_list=informative_terms)

                    terms_embedding_column = tf.feature_column.embedding_column(terms_feature_column, dimension=2)
                    feature_columns = [ terms_embedding_column ]

                    my_optimizer = tf.train.AdagradOptimizer(learning_rate=0.1)
                    my_optimizer = tf.contrib.estimator.clip_gradients_by_norm(my_optimizer, 5.0)

                    classifier = tf.estimator.DNNClassifier(
                      feature_columns=feature_columns,
                      hidden_units=[10,10],
                      optimizer=my_optimizer
                    )

                    classifier.train(
                      input_fn=lambda: _input_fn([train_path]),
                      steps=1000)

                    evaluation_metrics = classifier.evaluate(
                      input_fn=lambda: _input_fn([train_path]),
                      steps=1000)
                    print("Training set metrics:")
                    for m in evaluation_metrics:
                      print(m, evaluation_metrics[m])
                    print("---")

                    evaluation_metrics = classifier.evaluate(
                      input_fn=lambda: _input_fn([test_path]),
                      steps=1000)

                    print("Test set metrics:")
                    for m in evaluation_metrics:
                      print(m, evaluation_metrics[m])
                    print("---")

                    # I want to look at the shape of the neural network
                    classifier.get_variable_names()

                    classifier.get_variable_value('dnn/input_from_feature_columns/input_layer/terms_embedding/embedding_weights').shape

                    import numpy as np
                    import matplotlib.pyplot as plt

                    embedding_matrix = classifier.get_variable_value('dnn/input_from_feature_columns/input_layer/terms_embedding/embedding_weights')

                    for term_index in range(len(informative_terms)):
                      # Create a one-hot encoding for our term. It has 0s everywhere, except for
                      # a single 1 in the coordinate that corresponds to that term.
                      term_vector = np.zeros(len(informative_terms))
                      term_vector[term_index] = 1
                      #  project the one-hot vector into the embedding space.
                      embedding_xy = np.matmul(term_vector, embedding_matrix)
                      plt.text(embedding_xy[0],
                              embedding_xy[1],
                              informative_terms[term_index])

                    # Do a little setup to make sure the plot displays nicely.
                    plt.rcParams["figure.figsize"] = (15, 15)
                    plt.xlim(1.2 * embedding_matrix.min(), 1.2 * embedding_matrix.max())
                    plt.ylim(1.2 * embedding_matrix.min(), 1.2 * embedding_matrix.max())
                    plt.show() 
                  </code></pre>

                </div>
                <div class="centre">
                  <h1>Results:</h1>
                  <img src="assets/reviews-code.png">
                  <img src="assets/reviews-graph1.png">
                </div>
              </div>
            </main>
          </div>
    </body>
</html>